#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.Collections.Generic;

namespace EssentialDocIOSamples
{

    public class Form1 : System.Windows.Forms.Form
    {
        #region Private Members

        private ToolTip toolTip1;
        private Button button1;
        private PictureBox pictureBox1;
        private Label label2;
        private Button button2;
        private IContainer components;

        #endregion

        #region Constructor, Main and Dispose
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.label2 = new System.Windows.Forms.Label();
            this.button2 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(331, 236);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(110, 25);
            this.button1.TabIndex = 62;
            this.button1.Text = "Generate V1";
            this.button1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(623, 97);
            this.pictureBox1.TabIndex = 60;
            this.pictureBox1.TabStop = false;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label2.Location = new System.Drawing.Point(7, 107);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(366, 44);
            this.label2.TabIndex = 68;
            this.label2.Text = "Click the button to view the Word document generated by Essential DocIO. Please n" +
    "ote that MS Word Viewer or MS Word is required to view the resultant document.";
            // 
            // button2
            // 
            this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button2.BackColor = System.Drawing.Color.Transparent;
            this.button2.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button2.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button2.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button2.Image = ((System.Drawing.Image)(resources.GetObject("button2.Image")));
            this.button2.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button2.Location = new System.Drawing.Point(447, 236);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(110, 25);
            this.button2.TabIndex = 69;
            this.button2.Text = "Generate V2";
            this.button2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button2.UseVisualStyleBackColor = false;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(623, 371);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Generate Word";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        #region Button_Click Event
        private void button1_Click(object sender, System.EventArgs e)
        {
            //Sets ClearFields to true to remove empty mail merge fields from document
           
            string inputPath = Application.StartupPath + @"\..\..\Data\Template.doc";
            //Creates a new document
            WordDocument document = new WordDocument(inputPath);
            // Gets the reports as IEnumerable collection
              List<Employee> reportList = GetReports();
            //Creates an instance of MailMergeDataTable by specifying mail merge group name and IEnumerable collection
             MailMergeDataTable dataTable = new MailMergeDataTable("Employee", reportList);
            document.MailMerge.ClearFields = false;
            //Sets field value
            //document.MailMerge.BeforeClearField += new BeforeClearFieldEventHandler(BeforeClearFieldEvent);


            string[] fieldName1 = new string[] { "FirstName" };
            string[] fieldValue1 = new string[] { "John" };
            document.MailMerge.Execute(fieldName1, fieldValue1);
            string[] fieldName2 = new string[] { "LastName" };
            string[] fieldValue2 = new string[] { "Snow" };
            document.MailMerge.Execute(fieldName2, fieldValue2);
            string[] fieldName3 = new string[] { "ThereAreUsers" };
            string[] fieldValue3 = new string[] { "" };
            document.MailMerge.Execute(fieldName3, fieldValue3);


            //Performs Mail merge
            document.MailMerge.ExecuteGroup(dataTable);

            document.MailMerge.ExecuteGroup(GetProductsDataTable());

            document.MailMerge.ExecuteGroup(GetUsersDataTable());
            document.UpdateDocumentFields();
            //Saves and closes the WordDocument instance
            document.Save("Sample1.doc");
            document.Close();

            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                try
                {
                    //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                    System.Diagnostics.Process.Start("Sample1.doc");
                    //Exit
                    this.Close();
                }
                catch (Win32Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            // Exit
            this.Close();

        }

        private DataTable GetProductsDataTable()
        {
            //List of syncfusion products name
            string[] products = { "DocIO", "PDF", "XlsIO" };
            //Adds new Tables to the data set
            DataRow row;
            DataTable table = new DataTable();
            //Adds fields to the Products table
            table.TableName = "Products";
            table.Columns.Add("ProductName");
            table.Columns.Add("Binary");
            table.Columns.Add("Source");
            //Inserts values to the tables
            foreach (string product in products)
            {
                row = table.NewRow();
                row["ProductName"] = string.Concat("Essential ", product);
                row["Binary"] = "$895.00";
                row["Source"] = "$1,295.00";
                table.Rows.Add(row);
            }
            return table;
        }

        private DataTable GetUsersDataTable()
        {
            //List of syncfusion products name
            string[] products = { "John", "Sam", "Dave" };
            //Adds new Tables to the data set
            DataRow row;
            DataTable table = new DataTable();
            //Adds fields to the Products table
            table.TableName = "Users";
            table.Columns.Add("UserName");
            table.Columns.Add("Age");
            table.Columns.Add("City");
            //Inserts values to the tables
            foreach (string product in products)
            {
                row = table.NewRow();
                row["UserName"] = string.Concat("Sir ", product);
                row["Age"] = "33";
                row["City"] = "Warsaw";
                table.Rows.Add(row);
            }
            return table;
        }

        //Gets data
        public  List<Employee> GetReports()
        {
            //Creates mail merge Details
            List<Customer> customer1 = new List<Customer>();
            customer1.Add(new Customer(string.Empty));
            //Creates AgedReceivables reports
            List<Employee> reports = new List<Employee>();
            reports.Add(new Employee("1", customer1));

            List<Customer> customer2 = new List<Customer>();
            customer2.Add(new Customer("Simon"));

            reports.Add(new Employee("2", customer2));
            return reports;
        }
        /// <summary>
        /// Gets report details
        /// </summary>
        public class Employee
        {
            public string ChapterNumber { get; set; }
            public List<Customer> Customer { get; set; }
            public Employee(string name, List<Customer> cutsomer)
            {
                ChapterNumber = name;
                Customer = cutsomer;
            }
        }
        /// <summary>
        /// Gets mail merge details
        /// </summary>
        public class Customer
        {
            public string ChapterName { get; set; }
           
            public Customer(string chapterName)
            {
                ChapterName = chapterName;
            }
        }
        /// <summary>
        /// Performs event to set field value
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        private  void BeforeClearFieldEvent(object sender, BeforeClearFieldEventArgs args)
        {
            if (args.FieldName == "ThereAreUsers")
            {
                //If field value is empty, you can set whether the unmerged merge field can be clear or not
                args.ClearField = true;
            }
        }
        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            //Sets ClearFields to true to remove empty mail merge fields from document

            string inputPath = Application.StartupPath + @"\..\..\Data\Template.doc";
            //Creates a new document
            WordDocument document = new WordDocument(inputPath);
            // Gets the reports as IEnumerable collection
            List<Employee> reportList = GetReports();
            //Creates an instance of MailMergeDataTable by specifying mail merge group name and IEnumerable collection
            MailMergeDataTable dataTable = new MailMergeDataTable("Employee", reportList);
            document.MailMerge.ClearFields = false;
            ////Performs Mail merge
            document.MailMerge.ExecuteGroup(dataTable);

            document.MailMerge.ExecuteGroup(GetProductsDataTable());

            string[] fieldName1 = new string[] { "FirstName" };
            string[] fieldValue1 = new string[] { "John" };
            document.MailMerge.Execute(fieldName1, fieldValue1);
            string[] fieldName2 = new string[] { "LastName" };
            string[] fieldValue2 = new string[] { "Snow" };
            document.MailMerge.Execute(fieldName2, fieldValue2);

          
            string[] fieldName3 = new string[] { "ThereAreUsers" };
            string[] fieldValue3 = new string[] { "" };
            //If field value is empty, you can set whether the unmerged merge field can be clear or not, to update IF field properly
            document.MailMerge.ClearFields = true;
            document.MailMerge.Execute(fieldName3, fieldValue3);
            //Update IF Field in the Word document
            document.UpdateDocumentFields();

           

            //Saves and closes the WordDocument instance
            document.Save("Sample.doc");
            document.Close();

            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                try
                {
                    //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                    System.Diagnostics.Process.Start("Sample.doc");
                    //Exit
                    this.Close();
                }
                catch (Win32Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            // Exit
            this.Close();

        }
    }
}

